CSFML - C binding of the Simple and Fast Multimedia Library

CSFML
Functions
Shader.h File Reference
`#include <SFML/Graphics/Export.h>`
`#include <SFML/Graphics/Color.h>`
`#include <SFML/Graphics/Glsl.h>`
`#include <SFML/Graphics/Transform.h>`
`#include <SFML/Graphics/Types.h>`
`#include <SFML/System/InputStream.h>`
`#include <SFML/System/Vector2.h>`
`#include <SFML/System/Vector3.h>`
`#include <stddef.h>`

Go to the source code of this file.

## Functions
CSFML_GRAPHICS_API sfShader * | sfShader_createFromFile (const char *vertexShaderFilename, const char *geometryShaderFilename, const char *fragmentShaderFilename)
| Load the vertex, geometry and fragment shaders from files. More...
CSFML_GRAPHICS_API sfShader * | sfShader_createFromMemory (const char *vertexShader, const char *geometryShader, const char *fragmentShader)
| Load the vertex, geometry and fragment shaders from source code in memory. More...
CSFML_GRAPHICS_API sfShader * | sfShader_createFromStream (sfInputStream *vertexShaderStream, sfInputStream *geometryShaderStream, sfInputStream *fragmentShaderStream)
| Load the vertex, geometry and fragment shaders from custom streams. More...
CSFML_GRAPHICS_API void | sfShader_destroy (sfShader *shader)
| Destroy an existing shader. More...
CSFML_GRAPHICS_API void | sfShader_setFloatUniform (sfShader *shader, const char *name, float x)
| Specify value for `float` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec2Uniform (sfShader *shader, const char *name, sfGlslVec2 vector)
| Specify value for `vec2` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec3Uniform (sfShader *shader, const char *name, sfGlslVec3 vector)
| Specify value for `vec3` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec4Uniform (sfShader *shader, const char *name, sfGlslVec4 vector)
| Specify value for `vec4` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setColorUniform (sfShader *shader, const char *name, sfColor color)
| Specify value for `vec4` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setIntUniform (sfShader *shader, const char *name, int x)
| Specify value for `int` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setIvec2Uniform (sfShader *shader, const char *name, sfGlslIvec2 vector)
| Specify value for `ivec2` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setIvec3Uniform (sfShader *shader, const char *name, sfGlslIvec3 vector)
| Specify value for `ivec3` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setIvec4Uniform (sfShader *shader, const char *name, sfGlslIvec4 vector)
| Specify value for `ivec4` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setIntColorUniform (sfShader *shader, const char *name, sfColor color)
| Specify value for `ivec4` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setBoolUniform (sfShader *shader, const char *name, sfBool x)
| Specify value for `bool` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setBvec2Uniform (sfShader *shader, const char *name, sfGlslBvec2 vector)
| Specify value for `bvec2` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setBvec3Uniform (sfShader *shader, const char *name, sfGlslBvec3 vector)
| Specify value for `Bvec3` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setBvec4Uniform (sfShader *shader, const char *name, sfGlslBvec4 vector)
| Specify value for `bvec4` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setMat3Uniform (sfShader *shader, const char *name, const sfGlslMat3 *matrix)
| Specify value for `mat3` matrix. More...
CSFML_GRAPHICS_API void | sfShader_setMat4Uniform (sfShader *shader, const char *name, const sfGlslMat4 *matrix)
| Specify value for `mat4` matrix. More...
CSFML_GRAPHICS_API void | sfShader_setTextureUniform (sfShader *shader, const char *name, const sfTexture *texture)
| Specify a texture as `sampler2D` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setCurrentTextureUniform (sfShader *shader, const char *name)
| Specify current texture as `sampler2D` uniform. More...
CSFML_GRAPHICS_API void | sfShader_setFloatUniformArray (sfShader *shader, const char *name, const float *scalarArray, size_t length)
| Specify values for `float`[] array uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec2UniformArray (sfShader *shader, const char *name, const sfGlslVec2 *vectorArray, size_t length)
| Specify values for `vec2`[] array uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec3UniformArray (sfShader *shader, const char *name, const sfGlslVec3 *vectorArray, size_t length)
| Specify values for `vec3`[] array uniform. More...
CSFML_GRAPHICS_API void | sfShader_setVec4UniformArray (sfShader *shader, const char *name, const sfGlslVec4 *vectorArray, size_t length)
| Specify values for `vec4`[] array uniform. More...
CSFML_GRAPHICS_API void | sfShader_setMat3UniformArray (sfShader *shader, const char *name, const sfGlslMat3 *matrixArray, size_t length)
| Specify values for `mat3`[] array uniform. More...
CSFML_GRAPHICS_API void | sfShader_setMat4UniformArray (sfShader *shader, const char *name, const sfGlslMat4 *matrixArray, size_t length)
| Specify values for `mat4`[] array uniform. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setFloatParameter (sfShader *shader, const char *name, float x)
| Change a float parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setFloat2Parameter (sfShader *shader, const char *name, float x, float y)
| Change a 2-components vector parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setFloat3Parameter (sfShader *shader, const char *name, float x, float y, float z)
| Change a 3-components vector parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setFloat4Parameter (sfShader *shader, const char *name, float x, float y, float z, float w)
| Change a 4-components vector parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setVector2Parameter (sfShader *shader, const char *name, sfVector2f vector)
| Change a 2-components vector parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setVector3Parameter (sfShader *shader, const char *name, sfVector3f vector)
| Change a 3-components vector parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setColorParameter (sfShader *shader, const char *name, sfColor color)
| Change a color parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setTransformParameter (sfShader *shader, const char *name, sfTransform transform)
| Change a matrix parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setTextureParameter (sfShader *shader, const char *name, const sfTexture *texture)
| Change a texture parameter of a shader. More...
CSFML_GRAPHICS_API CSFML_DEPRECATED void | sfShader_setCurrentTextureParameter (sfShader *shader, const char *name)
| Change a texture parameter of a shader. More...
CSFML_GRAPHICS_API unsigned int | sfShader_getNativeHandle (const sfShader *shader)
| Get the underlying OpenGL handle of the shader. More...
CSFML_GRAPHICS_API void | sfShader_bind (const sfShader *shader)
| Bind a shader for rendering (activate it) More...
CSFML_GRAPHICS_API sfBool | sfShader_isAvailable (void)
| Tell whether or not the system supports shaders. More...
CSFML_GRAPHICS_API sfBool | sfShader_isGeometryAvailable (void)
| Tell whether or not the system supports geometry shaders. More...

## Function Documentation

## ◆ sfShader_bind()

CSFML_GRAPHICS_API void sfShader_bind | ( | const sfShader * | shader | ) |

Bind a shader for rendering (activate it)

This function is not part of the graphics API, it mustn't be used when drawing SFML entities. It must be used only if you mix sfShader with OpenGL code.

sfShader *s1, *s2;
...
sfShader_bind(s1);
// draw OpenGL stuff that use s1...
sfShader_bind(s2);
// draw OpenGL stuff that use s2...
sfShader_bind(0);
// draw OpenGL stuff that use no shader...

Parameters

  shader | Shader to bind, can be null to use no shader

## ◆ sfShader_createFromFile()

CSFML_GRAPHICS_API sfShader* sfShader_createFromFile | ( | const char * | vertexShaderFilename,
|  | const char * | geometryShaderFilename,
|  | const char * | fragmentShaderFilename
| ) |  |

Load the vertex, geometry and fragment shaders from files.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The sources must be text files containing valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderFilename | Path of the vertex shader file to load, or NULL to skip this shader
  geometryShaderFilename | Path of the geometry shader file to load, or NULL to skip this shader
  fragmentShaderFilename | Path of the fragment shader file to load, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_createFromMemory()

CSFML_GRAPHICS_API sfShader* sfShader_createFromMemory | ( | const char * | vertexShader,
|  | const char * | geometryShader,
|  | const char * | fragmentShader
| ) |  |

Load the vertex, geometry and fragment shaders from source code in memory.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The sources must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShader | String containing the source code of the vertex shader, or NULL to skip this shader
  geometryShader | String containing the source code of the geometry shader, or NULL to skip this shader
  fragmentShader | String containing the source code of the fragment shader, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_createFromStream()

CSFML_GRAPHICS_API sfShader* sfShader_createFromStream | ( | sfInputStream * | vertexShaderStream,
|  | sfInputStream * | geometryShaderStream,
|  | sfInputStream * | fragmentShaderStream
| ) |  |

Load the vertex, geometry and fragment shaders from custom streams.

This function loads the vertex, geometry and fragment shaders. Pass NULL if you don't want to load a specific shader. The source codes must be valid shaders in GLSL language. GLSL is a C-like language dedicated to OpenGL shaders; you'll probably need to read a good documentation for it before writing your own shaders.

Parameters

  vertexShaderStream | Source stream to read the vertex shader from, or NULL to skip this shader
  geometryShaderStream | Source stream to read the geometry shader from, or NULL to skip this shader
  fragmentShaderStream | Source stream to read the fragment shader from, or NULL to skip this shader

Returns
  A new sfShader object, or NULL if it failed

## ◆ sfShader_destroy()

CSFML_GRAPHICS_API void sfShader_destroy | ( | sfShader * | shader | ) |

Destroy an existing shader.

Parameters

  shader | Shader to delete

## ◆ sfShader_getNativeHandle()

CSFML_GRAPHICS_API unsigned int sfShader_getNativeHandle | ( | const sfShader * | shader | ) |

Get the underlying OpenGL handle of the shader.

You shouldn't need to use this function, unless you have very specific stuff to implement that SFML doesn't support, or implement a temporary workaround until a bug is fixed.

Parameters

  shader | Shader object

Returns
  OpenGL handle of the shader or 0 if not yet loaded

## ◆ sfShader_isAvailable()

CSFML_GRAPHICS_API sfBool sfShader_isAvailable | ( | void |  | ) |

Tell whether or not the system supports shaders.

This function should always be called before using the shader features. If it returns false, then any attempt to use sfShader will fail.

Returns
  sfTrue if the system can use shaders, sfFalse otherwise

## ◆ sfShader_isGeometryAvailable()

CSFML_GRAPHICS_API sfBool sfShader_isGeometryAvailable | ( | void |  | ) |

Tell whether or not the system supports geometry shaders.

This function should always be called before using the geometry shader features. If it returns false, then any attempt to use sfShader geometry shader features will fail.

This function can only return true if isAvailable() would also return true, since shaders in general have to be supported in order for geometry shaders to be supported as well.

Note: The first call to this function, whether by your code or SFML will result in a context switch.

Returns
  True if geometry shaders are supported, false otherwise

## ◆ sfShader_setBoolUniform()

CSFML_GRAPHICS_API void sfShader_setBoolUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfBool | x
| ) |  |

Specify value for `bool` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the bool scalar

## ◆ sfShader_setBvec2Uniform()

CSFML_GRAPHICS_API void sfShader_setBvec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec2 | vector
| ) |  |

Specify value for `bvec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the bvec2 vector

## ◆ sfShader_setBvec3Uniform()

CSFML_GRAPHICS_API void sfShader_setBvec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec3 | vector
| ) |  |

Specify value for `Bvec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the Bvec3 vector

## ◆ sfShader_setBvec4Uniform()

CSFML_GRAPHICS_API void sfShader_setBvec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslBvec4 | vector
| ) |  |

Specify value for `bvec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslIvec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the bvec4 vector

## ◆ sfShader_setColorParameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setColorParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color
| ) |  |

Change a color parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x1 vector (vec4 GLSL type).

It is important to note that the components of the color are normalized before being passed to the shader. Therefore, they are converted from range [0 .. 255] to range [0 .. 1]. For example, a sf::Color(255, 125, 0, 255) will be transformed to a vec4(1.0, 0.5, 0.0, 1.0) in the shader.

Example:

uniform vec4 color; // this is the variable in the shader
sfShader_setColorParameter(shader, "color", sfColor_fromRGB(255, 128, 0));

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  color | Color to assign

## ◆ sfShader_setColorUniform()

CSFML_GRAPHICS_API void sfShader_setColorUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color
| ) |  |

Specify value for `vec4` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  color | Value of the vec4 vector

## ◆ sfShader_setCurrentTextureParameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setCurrentTextureParameter | ( | sfShader * | shader,
|  | const char * | name
| ) |  |

Change a texture parameter of a shader.

This function maps a shader texture variable to the texture of the object being drawn, which cannot be known in advance. The corresponding parameter in the shader must be a 2D texture (sampler2D GLSL type).

Example:

uniform sampler2D current; // this is the variable in the shader
sfShader_setCurrentTextureParameter(shader, "current");

Parameters

  shader | Shader object
  name | Name of the texture in the shader

## ◆ sfShader_setCurrentTextureUniform()

CSFML_GRAPHICS_API void sfShader_setCurrentTextureUniform | ( | sfShader * | shader,
|  | const char * | name
| ) |  |

Specify current texture as `sampler2D` uniform.

This overload maps a shader texture variable to the texture of the object being drawn, which cannot be known in advance. The corresponding parameter in the shader must be a 2D texture (`sampler2D` GLSL type).

Example:

uniform sampler2D current; // this is the variable in the shader
sfShader_setCurrentTextureUniform(shader, "current");

Parameters

  shader | Shader object
  name | Name of the texture in the shader

## ◆ sfShader_setFloat2Parameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setFloat2Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y
| ) |  |

Change a 2-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2x1 vector (vec2 GLSL type).

Example:

uniform vec2 myparam; // this is the variable in the shader
sfShader_setFloat2Parameter(shader, "myparam", 5.2f, 6.0f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign

## ◆ sfShader_setFloat3Parameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setFloat3Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y,
|  | float | z
| ) |  |

Change a 3-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 3x1 vector (vec3 GLSL type).

Example:

uniform vec3 myparam; // this is the variable in the shader
sfShader_setFloat3Parameter(shader, "myparam", 5.2f, 6.0f, -8.1f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign
  z | Third component of the value to assign

## ◆ sfShader_setFloat4Parameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setFloat4Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x,
|  | float | y,
|  | float | z,
|  | float | w
| ) |  |

Change a 4-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x1 vector (vec4 GLSL type).

Example:

uniform vec4 myparam; // this is the variable in the shader
sfShader_setFloat4Parameter(shader, "myparam", 5.2f, 6.0f, -8.1f, 0.4f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | First component of the value to assign
  y | Second component of the value to assign
  z | Third component of the value to assign
  w | Fourth component of the value to assign

## ◆ sfShader_setFloatParameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setFloatParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x
| ) |  |

Change a float parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a float (float GLSL type).

Example:

uniform float myparam; // this is the variable in the shader
sfShader_setFloatParameter(shader, "myparam", 5.2f);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  x | Value to assign

## ◆ sfShader_setFloatUniform()

CSFML_GRAPHICS_API void sfShader_setFloatUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | float | x
| ) |  |

Specify value for `float` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the float scalar

## ◆ sfShader_setFloatUniformArray()

CSFML_GRAPHICS_API void sfShader_setFloatUniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const float * | scalarArray,
|  | size_t | length
| ) |  |

Specify values for `float`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  scalarArray | pointer to array of `float` values
  length | Number of elements in the array

## ◆ sfShader_setIntColorUniform()

CSFML_GRAPHICS_API void sfShader_setIntColorUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfColor | color
| ) |  |

Specify value for `ivec4` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  color | Value of the ivec4 vector

## ◆ sfShader_setIntUniform()

CSFML_GRAPHICS_API void sfShader_setIntUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | int | x
| ) |  |

Specify value for `int` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  x | Value of the integer scalar

## ◆ sfShader_setIvec2Uniform()

CSFML_GRAPHICS_API void sfShader_setIvec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec2 | vector
| ) |  |

Specify value for `ivec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec2 vector

## ◆ sfShader_setIvec3Uniform()

CSFML_GRAPHICS_API void sfShader_setIvec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec3 | vector
| ) |  |

Specify value for `ivec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec3 vector

## ◆ sfShader_setIvec4Uniform()

CSFML_GRAPHICS_API void sfShader_setIvec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslIvec4 | vector
| ) |  |

Specify value for `ivec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslIvec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the ivec4 vector

## ◆ sfShader_setMat3Uniform()

CSFML_GRAPHICS_API void sfShader_setMat3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat3 * | matrix
| ) |  |

Specify value for `mat3` matrix.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrix | Value of the mat3 matrix

## ◆ sfShader_setMat3UniformArray()

CSFML_GRAPHICS_API void sfShader_setMat3UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat3 * | matrixArray,
|  | size_t | length
| ) |  |

Specify values for `mat3`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrixArray | pointer to array of `mat3` values
  length | Number of elements in the array

## ◆ sfShader_setMat4Uniform()

CSFML_GRAPHICS_API void sfShader_setMat4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat4 * | matrix
| ) |  |

Specify value for `mat4` matrix.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrix | Value of the mat4 matrix

## ◆ sfShader_setMat4UniformArray()

CSFML_GRAPHICS_API void sfShader_setMat4UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslMat4 * | matrixArray,
|  | size_t | length
| ) |  |

Specify values for `mat4`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  matrixArray | pointer to array of `mat4` values
  length | Number of elements in the array

## ◆ sfShader_setTextureParameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setTextureParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfTexture * | texture
| ) |  |

Change a texture parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2D texture (sampler2D GLSL type).

Example:

uniform sampler2D the_texture; // this is the variable in the shader
sf::Texture texture;
...
sfShader_setTextureParameter(shader, "the_texture", texture);

It is important to note that texture must remain alive as long as the shader uses it, no copy is made internally.

To use the texture of the object being draw, which cannot be known in advance, you can use the special function sfShader_setCurrentTextureParameter:

sfShader_setCurrentTextureParameter(shader, "the_texture").

Parameters

  shader | Shader object
  name | Name of the texture in the shader
  texture | Texture to assign

## ◆ sfShader_setTextureUniform()

CSFML_GRAPHICS_API void sfShader_setTextureUniform | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfTexture * | texture
| ) |  |

Specify a texture as `sampler2D` uniform.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2D texture (`sampler2D` GLSL type).

Example:

uniform sampler2D the_texture; // this is the variable in the shader
sfTexture texture;
...
sfShader_setTextureUniform(shader, "the_texture", &texture);

It is important to note that texture must remain alive as long as the shader uses it, no copy is made internally.

To use the texture of the object being drawn, which cannot be known in advance, you can pass the special value sf::Shader::CurrentTexture:

shader.setUniform("the_texture", sf::Shader::CurrentTexture).

Parameters

  shader | Shader object
  name | Name of the texture in the shader
  texture | Texture to assign

## ◆ sfShader_setTransformParameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setTransformParameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfTransform | transform
| ) |  |

Change a matrix parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 4x4 matrix (mat4 GLSL type).

Example:

uniform mat4 matrix; // this is the variable in the shader
@todo
sfShader_setTransformParameter(shader, "matrix", transform);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  transform | Transform to assign

## ◆ sfShader_setVec2Uniform()

CSFML_GRAPHICS_API void sfShader_setVec2Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec2 | vector
| ) |  |

Specify value for `vec2` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec2 vector

## ◆ sfShader_setVec2UniformArray()

CSFML_GRAPHICS_API void sfShader_setVec2UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec2 * | vectorArray,
|  | size_t | length
| ) |  |

Specify values for `vec2`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec2` values
  length | Number of elements in the array

## ◆ sfShader_setVec3Uniform()

CSFML_GRAPHICS_API void sfShader_setVec3Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec3 | vector
| ) |  |

Specify value for `vec3` uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec3 vector

## ◆ sfShader_setVec3UniformArray()

CSFML_GRAPHICS_API void sfShader_setVec3UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec3 * | vectorArray,
|  | size_t | length
| ) |  |

Specify values for `vec3`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec3` values
  length | Number of elements in the array

## ◆ sfShader_setVec4Uniform()

CSFML_GRAPHICS_API void sfShader_setVec4Uniform | ( | sfShader * | shader,
|  | const char * | name,
|  | sfGlslVec4 | vector
| ) |  |

Specify value for `vec4` uniform.

sfColor objects can be passed to this function via the use of sfGlslVec4_fromsfColor(sfColor);

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vector | Value of the vec4 vector

## ◆ sfShader_setVec4UniformArray()

CSFML_GRAPHICS_API void sfShader_setVec4UniformArray | ( | sfShader * | shader,
|  | const char * | name,
|  | const sfGlslVec4 * | vectorArray,
|  | size_t | length
| ) |  |

Specify values for `vec4`[] array uniform.

Parameters

  shader | Shader object
  name | Name of the uniform variable in GLSL
  vectorArray | pointer to array of `vec4` values
  length | Number of elements in the array

## ◆ sfShader_setVector2Parameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setVector2Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfVector2f | vector
| ) |  |

Change a 2-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 2x1 vector (vec2 GLSL type).

Example:

uniform vec2 myparam; // this is the variable in the shader
sfVector2f vec = {5.2f, 6.0f};
sfShader_setVector2Parameter(shader, "myparam", vec);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  vector | Vector to assign

## ◆ sfShader_setVector3Parameter()

CSFML_GRAPHICS_API CSFML_DEPRECATED void sfShader_setVector3Parameter | ( | sfShader * | shader,
|  | const char * | name,
|  | sfVector3f | vector
| ) |  |

Change a 3-components vector parameter of a shader.

name is the name of the variable to change in the shader. The corresponding parameter in the shader must be a 3x1 vector (vec3 GLSL type).

Example:

uniform vec3 myparam; // this is the variable in the shader
sfVector3f vec = {5.2f, 6.0f, -8.1f};
sfShader_setVector3Parameter(shader, "myparam", vec);

Parameters

  shader | Shader object
  name | Name of the parameter in the shader
  vector | Vector to assign